<?php

namespace InforItem;

/**
 * Class which returns the class map definition
 * @package Item_
 */
class Item_ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ListRequestType' => '\\InforItem\\Item_ListRequestType',
            'ControlArea' => '\\InforItem\\Item_ControlArea',
            'ListResponseType' => '\\InforItem\\Item_ListResponseType',
            'DataArea' => '\\InforItem\\Item_DataArea',
            'ProductLine' => '\\InforItem\\Item_ProductLine',
            'ShowRequestType' => '\\InforItem\\Item_ShowRequestType',
            'ShowResponseType' => '\\InforItem\\Item_ShowResponseType',
            'ActivationType' => '\\InforItem\\Item_ActivationType',
            'InformationArea' => '\\InforItem\\Item_InformationArea',
            'Message' => '\\InforItem\\Item_Message',
            'MessageDetails' => '\\InforItem\\Item_MessageDetails',
            'MessageReference' => '\\InforItem\\Item_MessageReference',
            'DetailMessage' => '\\InforItem\\Item_DetailMessage',
            'InformationMessage' => '\\InforItem\\Item_InformationMessage',
            'FilterType' => '\\InforItem\\Item_FilterType',
            'LogicalExpressionType' => '\\InforItem\\Item_LogicalExpressionType',
            'ComparisonExpressionType' => '\\InforItem\\Item_ComparisonExpressionType',
            'EmptyValueType' => '\\InforItem\\Item_EmptyValueType',
            'SelectionType' => '\\InforItem\\Item_SelectionType',
        );
    }
}
